#include "abstract-gpio-init.hpp"
#include "abstract-gpio.hpp"

#ifndef GPIO_H
#define GPIO_H

namespace stm32f072xb {

template <Port T>
class Gpio : public AbstractGpio {
   public:
	Gpio(const AbstractGpioInit& gpioInit);
};

template <>
class Gpio<Port::A> : public AbstractGpio {
   public:
	Gpio(const AbstractGpioInit& gpioInit);
};

template <>
class Gpio<Port::B> : public AbstractGpio {
   public:
	Gpio(const AbstractGpioInit& gpioInit);
};

template <>
class Gpio<Port::C> : public AbstractGpio {
   public:
	Gpio(const AbstractGpioInit& gpioInit);
};

template <>
class Gpio<Port::D> : public AbstractGpio {
   public:
	Gpio(const AbstractGpioInit& gpioInit);
};

template <>
class Gpio<Port::E> : public AbstractGpio {
   public:
	Gpio(const AbstractGpioInit& gpioInit);
};

template <>
class Gpio<Port::F> : public AbstractGpio {
   public:
	Gpio(const AbstractGpioInit& gpioInit);
};

}  // namespace stm32f072xb
#endif
